/**
 * @author Marco Kümmel
 * @version Juni 2024
 */
public class Quadrat
{
    private int n; // Seitenlänge
    private boolean[] zahlGenutzt; // speichert, ob die Zahl "index+1" bereits genutzt wird
    private int[][] quadrat; // das Quadrat
    // [reihe][spalte]
    
    /**
     * Konstruktor für Objekte der Klasse Quadrat
     */
    public Quadrat(int seitenlaenge)
    {
        // this.n = 
        // this.zahlGenutzt = 
        // this.quadrat = 
    }

    public void loeseMagischesQuadrat() {
        fuelleFeld(0);
    }
    
    /**
     * Fülle das f-te Feld, ausgehend von links oben zeilenweise zählend.
     * U.a. mithilfe des Modulo-Operators werden Reihe und Spalte ermittelt.
     */
    private void fuelleFeld(int f) {
        
    }
    
    /**
     * Prüft auf allen Reihen, Spalten und den beiden Diagonalen, 
     * ob es Fehler im magischen Qudrat gibt.
     * Wichtig: Bei einer 0 in einer Reihung kann diese noch nicht überprüft werden.
     */
    private boolean quadratFehlerfrei() {
        int magischeZahl = ((n*n*n) + n ) / 2;
        
        // prüfe zunächst die reihen
        for (int reihe = 0; reihe < n; reihe++) {
            int summe = 0;
            boolean abgebrochen = false;
            
            for (int spalte = 0; spalte < n; spalte++) {
                if (quadrat[reihe][spalte] == 0) {
                    // beende die innere Schleife und mach in der nächsten Reihe weiter
                    abgebrochen = true;
                    break; 
                }
                summe += quadrat[reihe][spalte];
            }
            
            if (!abgebrochen && summe != magischeZahl) {
                return false;
            }
        }
        
        // prüfe die Spalten
        for (int spalte = 0; spalte < n; spalte++) {
            int summe = 0;
            boolean abgebrochen = false;
            
            for (int reihe = 0; reihe < n; reihe++) {
                if (quadrat[reihe][spalte] == 0) {
                    // beende die innere Schleife und mach in der nächsten Spalte weiter
                    abgebrochen = true;
                    break; 
                }
                summe += quadrat[reihe][spalte];
            }
            
            if (!abgebrochen && summe != magischeZahl) {
                return false;
            }
        }
                
        // prüfe Diagonale von links oben nach rechts unten
        int summe = 0;
        boolean abgebrochen = false;
        for (int i = 0; i < n; i++) {
            if (quadrat[i][i] == 0) {
                abgebrochen = true;
                break;
            }
            summe += quadrat[i][i];
        }
        if (!abgebrochen && summe != magischeZahl) {
            return false;
        }
        
        // prüfe Diagonale von rechts oben nach links unten
        summe = 0;
        abgebrochen = false;
        for (int i = n; i > 0; i--) {
            if (quadrat[n-i][i-1] == 0) {
                abgebrochen = true;
                break;
            }
            summe += quadrat[n-i][i-1];
        }
        if (!abgebrochen && summe != magischeZahl) {
            return false;
        }
        
        return true;
    }
    
    /**
     * Druckt das magische Quadrat schön formatiert
     */
    private void druckeQuadrat() {
        for (int reihe = 0; reihe < n; reihe++) {
            for (int spalte = 0; spalte < n; spalte++) {
                if (quadrat[reihe][spalte] < 10) {
                    System.out.print(" ");
                }
                System.out.print(quadrat[reihe][spalte]);
                if (spalte < n-1) {
                    System.out.print("|");
                }
            }
            System.out.println();
        }
        System.out.println();
    }
}
